<?php

namespace App\Http\Controllers;

use App\Models\Restaurante;
use App\Models\Categoria;
use App\Services\PaginatorService;
use App\Services\UuidService;
use App\Exceptions\GenericException;
use App\Exceptions\ModelNotFoundException;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\Request;
use Illuminate\Validation\ValidationException;
use Ramsey\Uuid\Uuid;

class CategoriasController extends Controller {

    /**
     * Obtiene de forma paginada las categorias registradas en el backend
     */
    public function all(Request $request, $restaurante_id) {
        app(UuidService::class)->validOrFail($restaurante_id);
        $restaurante = Restaurante::findOrFail($restaurante_id);

        $categorias = $restaurante->categorias();

        $paginate = app(PaginatorService::class)->paginate(
            perPage: $request->input('per_page', 15),
            page: $request->input('page', 1),
            total: $categorias->count(),
            route: 'restaurant.all',
            data: ['restaurante_id' => $restaurante_id]
        );

        $data = $categorias->get()
                           ->skip($paginate['from'] - 1)
                           ->take($paginate['per_page'])
                           ->all();

        return response()->json([
            'pagination' => $paginate,
            'data' => $data
        ]);
    }

    /**
     * Obtiene una categoria por su id
     */
    public function get(Request $request, $restaurante_id, $id) {
        app(UuidService::class)->validOrFail($restaurante_id);
        app(UuidService::class)->validOrFail($id);

        $restaurante = Restaurante::findOrFail($restaurante_id);
        $categoria = Categoria::findOrFail($id);

        if($categoria->restaurante != $restaurante) {
            throw new ModelNotFoundException("categoria", $id);
        }

        return response()->json($categoria);
    }

    /**
     * Crea una nueva categoria
     */
    public function create(Request $request, $restaurante_id) {
        app(UuidService::class)->validOrFail($restaurante_id);
        $restaurante = Restaurante::findOrFail($restaurante_id);

        $this->validate($request, [
            'nombre' => 'required'
        ]);

        $categoria = Categoria::create([
            'id' => Uuid::uuid4(),
            'nombre' => $request->input('nombre'),
            'restaurante_id' => $restaurante->id
        ]);

        return response()->json($categoria, 201);
    }

    /**
     * Actualiza un categoria
     */
    public function update(Request $request, $restaurante_id, $id) {
        app(UuidService::class)->validOrFail($restaurante_id);
        app(UuidService::class)->validOrFail($id);

        $this->validate($request, [
            'nombre' => 'required'
        ]);

        $restaurante = Restaurante::findOrFail($restaurante_id);
        $categoria = Categoria::findOrFail($id);

        if($categoria->restaurante != $restaurante) {
            throw new ModelNotFoundException("categoria", $id);
        }

        $categoria->nombre = $request->input('nombre');
        $categoria->save();

        return response()->json($categoria);
    }

    /**
     * Elimina una categoria
     */
    public function delete(Request $request, $restaurante_id, $id) {
        app(UuidService::class)->validOrFail($restaurante_id);
        app(UuidService::class)->validOrFail($id);

        $restaurante = Restaurante::findOrFail($restaurante_id);
        $categoria = Categoria::findOrFail($id);

        if($categoria->restaurante != $restaurante) {
            throw new ModelNotFoundException("categoria", $id);
        }

        $categoria->delete();

        return response()->json([], 204);
    }
}
